<%@ Page language="c#" AutoEventWireup="false" Inherits="Microsoft.Exchange.Clients.Owa.Core.Logon" %>
<%@ Import namespace="com.swivelsecure.pinsafe"%>
<%@ Import namespace="System.Collections.Generic"%>
<%@ Import namespace="System.Diagnostics"%>
<%@ Import namespace="Microsoft.Exchange.Clients"%>
<%@ Import namespace="Microsoft.Exchange.Clients.Owa.Core"%>
<%@ Import namespace="Microsoft.Exchange.Clients.Owa.Premium"%>
<%@ Import Namespace="System.Net" %>
<!-- {57A118C6-2DA9-419d-BE9A-F92B0F9A418B} --> 
<% if (!ReplaceCurrent) { %>
<html>
<head>
<link type="text/css" rel="stylesheet" href="<%=OwaUrl.ApplicationRoot.ImplicitUrl%><%ThemeManager.RenderBaseThemeFileUrl(Response.Output, ThemeFileId.LogonCss);%>">
<link type="text/css" rel="stylesheet" href="<%=OwaUrl.ApplicationRoot.ImplicitUrl%>8.2.301.0/themes/base/<%= Utilities.GetDefaultCultureFontCssFileUrl(OwaContext) %>">
<script type="text/javascript" src="<%=OwaUrl.ApplicationRoot.ImplicitUrl%>8.2.301.0/scripts/premium/flogon.js"></script>
<script type="text/javascript">
	<!--
	var a_fRC = 0;
	var a_sUrl = "&url=<%=Utilities.JavascriptEncode(Utilities.UrlEncode(Destination)) %>";
	var a_sCW = "<%=Utilities.JavascriptEncode(CloseWindowUrl) %>";
	var a_sLgnQS = "<% RenderLogonQueryString(); %>";
	-->
</script>
</head>
<body class="owaLgnBdy">
<noscript>
	<div id="dvErr">
		<table cellpadding="0" cellspacing="0">
		<tr>
			<td><img src="<%=OwaUrl.ApplicationRoot.ImplicitUrl%><%ThemeManager.RenderBaseThemeFileUrl(Response.Output, ThemeFileId.Error);%>"></td>
			<td style="width:100%"><%=Utilities.GetNoScriptHtml() %></td>
		</tr>
		</table>
	</div>
</noscript>
</body>
</html>
<% } else { %>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN"> 
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; CHARSET=utf-8">
<meta name="Robots" content="NOINDEX, NOFOLLOW">
<title><%=LocalizedStrings.GetHtmlEncoded(Strings.IDs.OutlookWebAccess) %></title>
<link type="text/css" rel="stylesheet" href="<%=OwaUrl.ApplicationRoot.ImplicitUrl%><%ThemeManager.RenderBaseThemeFileUrl(Response.Output, ThemeFileId.LogonCss);%>">
<link type="text/css" rel="stylesheet" href="<%=OwaUrl.ApplicationRoot.ImplicitUrl%>8.2.301.0/themes/base/<%= Utilities.GetDefaultCultureFontCssFileUrl(OwaContext) %>">
<script type="text/javascript" src="<%=OwaUrl.ApplicationRoot.ImplicitUrl%>8.2.301.0/scripts/premium/flogon.js"></script>

<script type="text/javascript">
	<!--
	var a_fRC = 1;
	var g_fFcs = 1;
	var a_fLOff = <%= (Reason == LogonReason.Logoff || Reason == LogonReason.ChangePasswordLogoff || Reason == LogonReason.Timeout) ? 1 : 0 %>;
	var a_fCAC = <%= ShouldClearAuthenticationCache ? 1 : 0 %>
/// <summary>
/// Is Mime Control installed?
/// </summary>
function IsMimeCtlInst(progid)
{
	var oMimeVer = null;

	try 
	{ 
		oMimeVer = new ActiveXObject(progid);
	} 
	catch (e)
	{ 
	}

	if (oMimeVer != null)
		return true;
	else
		return false;
}

/// <summary>
/// Render out the S-MIME control if it is installed.
/// </summary>
function RndMimeCtl()
{
	if (IsMimeCtlInst("MimeBhvr.MimeCtlVer"))
		RndMimeCtlHlpr("MimeNSe2k3", "D801B381-B81D-47a7-8EC4-EFC111666AC0", "MIMEe2k3", "mimeLogoffE2k3");

	if (IsMimeCtlInst("OwaSMime.MimeCtlVer"))
		RndMimeCtlHlpr("MimeNSe2k7sp1", "833aa5fb-7aca-4708-9d7b-c982bf57469a", "MIMEe2k7sp1", "mimeLogoffE2k7sp1");
}

/// <summary>
/// Helper function to factor out the rendering of the S/MIME control.
/// </summary>
function RndMimeCtlHlpr(objid, classid, ns, id)
{
	document.write("<OBJECT id='" + objid + "' classid='CLSID:" + classid + "'></OBJECT>");
	document.write("<?IMPORT namespace='" + ns + "' implementation=#" + objid + ">");
	document.write("<" + ns + ":Logoff id='" + id + "' style='display:none'/>");
}
		
var xmlHttp;

var XMLHttpFactories = [
	function () {return new XMLHttpRequest()},
	function () {return new ActiveXObject("Msxml3.XMLHTTP")},
	function () {return new ActiveXObject("Msxml2.XMLHTTP")},
	function () {return new ActiveXObject("Microsoft.XMLHTTP")}
];

function createXMLHttpRequest() {
	var xmlhttp = false;
	for (var i=0;i<XMLHttpFactories.length;i++) {
		try {
			xmlhttp = XMLHttpFactories[i]();
		}
		catch (e) {
			continue;
		}
		break;
	}
	return xmlhttp;
}

function onUserExists()
{
	if (xmlHttp.readyState != 4) return;
	var exists = false;
	if (xmlHttp.status == 200) {
		var resultText = xmlHttp.responseText;
		exists = (resultText.toLowerCase() == "true");
	}
	setUserExists(exists);
}

function setUserExists(exists)
{
	var rowOtc = document.getElementById("OTCRow");
	var rowTuring = document.getElementById("TuringRow");
	var chkPINsafeOff = document.getElementById("noPINsafe");
	if (exists) {
		if (rowOtc) {
			rowOtc.style.display = "";
		}
		if (rowTuring) {
			rowTuring.style.display = "";
			ShowTuring();
		}
		chkPINsafeOff.checked = false;
	} else {
		if (rowOtc) {
			rowOtc.style.display = "none";
		}
		if (rowTuring) {
			rowTuring.style.display = "none";
		}
		chkPINsafeOff.checked = true;
	}
}

function GetUsername()
{
	var userField = document.getElementById("username");
	if (!userField || !userField.value)
	{
		return null;
	}
	var username = userField.value;
	var idx = username.indexOf('\\');
	if (idx >= 0 && idx < username.length - 1)
	{
		username = username.substring(idx+1, 0);
	}
	idx = username.indexOf('@');
	if (idx > 0)
	{
		username = username.substring(0, idx);
	}
	return username;
}

function CheckUser()
{
<%     // Get PINsafe settings.
    PINsafeSettings settings = new PINsafeSettings();
    if (settings.AllowNonPINsafeUsers)
{%>
	var username = GetUsername();
	if (username && username != "")
	{
		var pinsafeUrl = "./CheckUser.aspx?username=" + username + "&random=" + Math.floor(Math.random()*100000);
		xmlHttp = createXMLHttpRequest();
		xmlHttp.onreadystatechange = onUserExists;
		xmlHttp.open("GET", pinsafeUrl, true);
		xmlHttp.send(null);
	} else {
		setUserExists(false);
	}
<% } else
{%>
    setUserExists(true);
<%
}%>
}

function ShowTuring()
{
	var username = GetUsername();
	if (username && username != "")
	{
		var thisRow = document.getElementById("OTCRow");
		thisRow.style.display = "";
		thisRow = document.getElementById("TuringRow");
		thisRow.style.display = "";
		var turing = document.getElementById("TuringImage");
		turing.src = "SCImage.aspx?username=" + username + "&random=" + Math.floor(Math.random()*100000);
	}
}

	-->
</script>

</head>
<body class="owaLgnBdy<%=IsRtl ? " rtl" : ""%>" onload="CheckUser();">
<% 
	string tblStyle = "cellpadding=0 cellspacing=0";
	if (IsDownLevelClient)
	{
		tblStyle = "class=\"nonMSIE\"";
	}
%>
<% if (!IsDownLevelClient) { %>
<script language="javascript">
	RndMimeCtl();
</script>
<% } %>
<noscript>
	<div id="dvErr">
		<table cellpadding="0" cellspacing="0">
		<tr>
			<td><img src="<%=OwaUrl.ApplicationRoot.ImplicitUrl%><%ThemeManager.RenderBaseThemeFileUrl(Response.Output, ThemeFileId.Error);%>" alt=""></td>
			<td style="width:100%"><%=Utilities.GetNoScriptHtml() %></td>
		</tr>
		</table>
	</div>
</noscript>
<form action="PINsafeLogon.aspx" method="POST" name="logonForm" autocomplete="off" onsubmit="pinsafeLogon();">
<input type="hidden" name="destination" value="<%=Utilities.HtmlEncode(Destination)%>">
<input type="hidden" name="flags" value="0">
<input type="hidden" name="forcedownlevel" value="0">
<table align="center" id="tblMain" cellpadding=0 cellspacing=0>
	<tr>
		<td colspan=3>
			<table cellspacing=0 cellpadding=0 class="tblLgn">
			<tr>
				<td class="lgnTL"><img src="/owa/<%ThemeManager.RenderBaseThemeFileUrl(Response.Output, ThemeFileId.LogonTopLeft);%>" alt=""></td>
				<td class="lgnTM"></td>
				<td class="lgnTR"><img src="/owa/<%ThemeManager.RenderBaseThemeFileUrl(Response.Output, ThemeFileId.LogonTopRight);%>" alt=""></td>
			</tr>
			</table>
		</td>
	</tr>
	<tr>
		<td id="mdLft">&nbsp;</td>
		<td id="mdMid">
			<table id="tblMid" class="mid">
				<tr>
					<td id="expltxt" class="expl">
					<%
					if (Reason == LogonReason.Logoff)
						Response.Write(LocalizedStrings.GetHtmlEncoded(Strings.IDs.LogoffMessage));
					else if (Reason == LogonReason.Timeout)
						Response.Write(LocalizedStrings.GetHtmlEncoded(Strings.IDs.TimeoutMessage));
					else if (Reason == LogonReason.ChangePasswordLogoff)
						Response.Write(LocalizedStrings.GetHtmlEncoded(Strings.IDs.LogoffChangePasswordMessage));
					%>					
					</td>
				</tr>
				<tr><td><hr></td></tr>
				<tr>
					<td>
						<table <%=tblStyle%>>
						<col>
						<col class="w100">
						<tr id=trSec>
							<td colspan="2">								
								<%=LocalizedStrings.GetHtmlEncoded(Strings.IDs.Security) %> 
									<%=(IsRtl ? "&#x200F;" : "&#x200E;") + LocalizedStrings.GetHtmlEncoded(Strings.IDs.OpenParentheses) %>
									<a href="#" id="lnkShwSec" onclick="clkExp('lnkShwSec')">
									<%=LocalizedStrings.GetHtmlEncoded(Strings.IDs.ShowExplanation) %> 
									</a>
									<a href="#" id="lnkHdSec" onclick="clkExp('lnkHdSec')" style="display:none">
									<%=LocalizedStrings.GetHtmlEncoded(Strings.IDs.HideExplanation) %> 
									</a>
								<%=LocalizedStrings.GetHtmlEncoded(Strings.IDs.CloseParentheses) + (IsRtl ? "&#x200F;" : "&#x200E;") %>
							</td>
						</tr>						
						<tr>
							<td><input id="rdoPblc" type="radio" name="trusted" value="0" class="rdo" onclick="clkSec()" checked></td>
							<td><label for="rdoPblc"><%=LocalizedStrings.GetHtmlEncoded(Strings.IDs.ThisIsAPublicOrSharedComputer) %></label></td>
						</tr>
						<tr id="trPubExp" class="expl" style="display:none">
							<td></td>
							<td><%=LocalizedStrings.GetHtmlEncoded(Strings.IDs.PublicExplanation) %></td>
						</tr>
						<tr>
							<td><input id="rdoPrvt" type="radio" name="trusted" value="4" class="rdo" onclick="clkSec()"></td>
							<td><label for="rdoPrvt"><%=LocalizedStrings.GetHtmlEncoded(Strings.IDs.ThisIsAPrivateComputer) %></label></td>
						</tr>
						<tr id="trPrvtExp" class="expl" style="display:none">
							<td></td>
							<td><%=LocalizedStrings.GetHtmlEncoded(Strings.IDs.PrivateExplanation) %></td>
						</tr>
						<tr id="trPrvtWrn" class="wrng" style="display:none">
							<td></td>
							<td><%=LocalizedStrings.GetHtmlEncoded(Strings.IDs.PrivateWarning) %></td>
						</tr>
						</table>
					</td>
				</tr>
				<tr><td><hr></td></tr>
				<tr>
					<td>
						<table <%=tblStyle%>>
							<col>
							<col class="w100">
							<% if (!IsDownLevelClient) { %>	
								<tr>							
									<td><input id="chkBsc" type="checkbox" class="rdo" onclick="clkBsc();"></td>
									<td nowrap><label for="chkBsc"><%=LocalizedStrings.GetHtmlEncoded(Strings.IDs.UseOutlookWebAccessBasicClient) %></label></td>
								</tr>
								<tr id="trBscExp" class="disBsc" style="display:none">
									<td></td>
									<td><%=LocalizedStrings.GetHtmlEncoded(Strings.IDs.BasicExplanation) %></td>
								</tr>
							<% } %>
							<% else { %>
								<tr>
									<td><input id="chkBsc" type="checkbox" class="rdo" onclick="clkBsc();" disabled checked></td>
									<td nowrap><label for="chkBsc"><%=LocalizedStrings.GetHtmlEncoded(Strings.IDs.UseOutlookWebAccessBasicClient) %></label></td>
								</tr>
								<tr id="trBscExp" class="disBsc">
									<td></td>
									<td><%=LocalizedStrings.GetHtmlEncoded(Strings.IDs.BasicExplanation) %></td>
							</tr>
							<% } %>
						</table>
					</td>
				</tr>
				<tr><td><hr></td></tr>
				<tr>
					<td>
						<table <%=tblStyle%>>
							<col class="nowrap">
							<col class="w100">
							<col>
							<tr>
								<td nowrap><label for="username"><%=UserNameLabel%></label></td>
								<td class="txtpad"><input id="username" name="username" type="text" class="txt" onblur="CheckUser();"></td>
							</tr>
							<tr>
								<td nowrap><label for="password"><%=LocalizedStrings.GetHtmlEncoded(Strings.IDs.PasswordColon) %></label></td>
								<td class="txtpad"><input id="password" name="password" type="password" class="txt" onfocus="g_fFcs=0"></td>
							</tr>
							<tr id="OTCRow" style="display:none">
								<td nowrap><label for="otc">One-Time Code:</label></td>
								<td class="txtpad"><input id="otc" name="otc" type="password" class="txt"><input type="checkbox" name="noPINsafe" id="noPINsafe" style="display:none"/></td>
							</tr>
							<tr>
								<td colspan=2 align="right" class="txtpad">
									<% if (!IsDownLevelClient) { %>
									<input type="submit" class="btn" value="<%=LocalizedStrings.GetHtmlEncoded(Strings.IDs.LogOn) %>" onclick="clkLgn()" 
										onmouseover="this.className='btnOnMseOvr'" onmouseout="this.className='btn'" onmousedown="this.className='btnOnMseDwn'">
									</input>
									<% } %>
									<% else { %>
									<input type="submit" class="btn" value="<%=LocalizedStrings.GetHtmlEncoded(Strings.IDs.LogOn) %>" onclick="clkLgn()">
									<% } %>
									<input name="isUtf8" type="hidden" value="1">
								</td>
							</tr>
							<tr id="TuringRow" style="display:none">
								<td colspan="2" align="center">
								    <input type="button" class="btn" value="New Security String" onclick="ShowTuring()" /><br />
									<img id="TuringImage" src="SCImage.aspx" />
								</td>
							</tr>
						</table>
					</td>
				</tr>
				<tr><td><hr></td></tr>
				<%
					if (Reason == LogonReason.InvalidCredentials) {
				%>
					<tr id="trInvCrd" class="wrng">
					<td><%=LocalizedStrings.GetHtmlEncoded(Strings.IDs.InvalidCredentialsMessage) %></td>
				</tr>
				<% } %>
			</table>
			<table id="tblMid2" class="mid" style="display:none">
				<tr><td><hr></td></tr>
				<tr>
					<td><br><%=string.Format(LocalizedStrings.GetHtmlEncoded(Strings.IDs.CookiesDisabledMessage), "<br><br>") %><br><br><br></td>
				</tr>
				<tr><td><hr></td></tr>
				<tr>
					<td align="right" class="txtpad">
					<% if (!IsDownLevelClient) { %>
						<input type="button" class="btn" style="float: right" value="<%=LocalizedStrings.GetHtmlEncoded(Strings.IDs.Retry) %>" onclick="clkRtry()" 
						onmouseover="this.className='btnOnMseOvr'" onmouseout="this.className='btn'" onmousedown="this.className='btnOnMseDwn'">
					<% } %>
					<% else { %>
						<input type="button" class="btn" style="float: right" value="<%=LocalizedStrings.GetHtmlEncoded(Strings.IDs.Retry) %>" onclick="clkRtry()">
					<% } %>
					</td>
				</tr>
			</table>
			<table class="mid tblConn">
				<tr>
					<td rowspan=2 align="right" class="tdConnImg"><img style="vertical-align:top" src="<%=OwaUrl.ApplicationRoot.ImplicitUrl%><%ThemeManager.RenderBaseThemeFileUrl(Response.Output, ThemeFileId.LogonExchangeLogo);%>" alt=""></td>
					<td class="tdConn"><%=LocalizedStrings.GetHtmlEncoded(Strings.IDs.ConnectedToExchange)%></td>
				</tr>
				<tr>
					<td class="tdCopy"><%=String.Format(LocalizedStrings.GetHtmlEncoded(Strings.IDs.LogonCopyright), "&copy;")%></td>
				</tr>
			</table>
		</td>
		<td id="mdRt">&nbsp;</td>
	</tr>
	<tr>
		<td colspan=3>
			<table cellspacing=0 cellpadding=0 class="tblLgn">
			<tr>
				<td class="lgnBL"><img src="/owa/<%ThemeManager.RenderBaseThemeFileUrl(Response.Output, ThemeFileId.LogonBottomLeft);%>" alt=""></td>
				<td class="lgnBM"></td>
				<td class="lgnBR"><img src="/owa/<%ThemeManager.RenderBaseThemeFileUrl(Response.Output, ThemeFileId.LogonBottomRight);%>" alt=""></td>
			</tr>
			</table>
		</td>
	</tr>
</table>
</form>
<% if (!IsDownLevelClient) { %><iframe src="<%=OwaUrl.ApplicationRoot.ImplicitUrl%>auth/preload.htm" style="display:none"></iframe><% } %>
</body>
</html>
<% } %>
